<template>
    <div class="report-overview">
        <el-table height="calc(100% - 40px)" :element-loading-background="loadingColor" v-loading="loading"
            :span-method="objectSpanMethod" align="center" :data="tableData" id="table-bigger-detail" class="dialog_table"
            :header-cell-style="{ 'text-align': 'center' }">
            <el-table-column prop="indexKey" label="序号" width="60" align="center">
            </el-table-column>
            <el-table-column prop="projectName" label="项目名称" align="left">
            </el-table-column>
            <el-table-column prop="unitName" label="主责单位" width="140" align="left">
            </el-table-column>
            <el-table-column prop="unitTeam" label="牵头专项小组" width="160" align="left">
            </el-table-column>
            <el-table-column prop="target1" :label="`组建\n工作专班`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target1.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target1.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target1.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target1 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target2" :label="`开展\n调查研究`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target2.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target2.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target2.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target2 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target3" :label="`制定\n改革方案`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target3.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target3.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target3.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target3 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target4" :label="`出台\n配套政策`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target4.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target4.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target4.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target4 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target5" :label="`向上\n争取支持`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target5.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target5.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target5.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target5 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target6" :label="`开展\n试点示范`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target6.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target6.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target6.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target6 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target7" :label="`开展\n督导指导`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target7.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target7.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target7.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target7 }}
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="target8" :label="`总结\n推广经验`" width="140" align="center">
                <template v-slot="{ row }">
                    <div :style="`${row.target8.indexOf('已完成') !== -1
                            ? 'background :#38a846'
                            : row.target8.indexOf('推进中') !== -1
                                ? 'background:#00b0f0'
                                : row.target8.indexOf('未启动') !== -1
                                    ? 'background:#f43308'
                                    : 'background:#d9d9d9;color:#333;'
                        }`">
                        {{ row.target8 }}
                    </div>
                </template>
            </el-table-column>
        </el-table>
        <div class="tips">
            备注：①绿色为已完成事项；②蓝色为推进中事项；③红色为未启动事项；④灰色为暂不涉及事项。
        </div>
    </div>
</template>
<script>
import apiList from '@/api/bigScreen/majorView.js'
export default {
    projectName: 'reportOverview',
    components: {},
    props: {
        tableOptions: {
            type: Object,
            default: () => {
                return {}
            },
        },
    },
    data() {
        return {
            loading: false,
            loadingColor: 'rgba(7, 45, 98,.4)',
            dataReady: false,
            tableData: [
                {
                    indexKey: 1,
                    projectName: '推动数字重庆建设',
                    unitName: '市委改革办市大数据发展局',
                    unitTeam: '',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '5月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '推进中',
                    target8: '未启动',
                },
                {
                    indexKey: 2,
                    projectName:
                        '推进“党建扎桩·治理结网”党建统领基层治理现代化改革',
                    unitName: '市委组织部',
                    unitTeam: '党建统领体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '3月已完成',
                    target4: '9月已完成',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '推进中',
                    target8: '推进中',
                },
                {
                    indexKey: 3,
                    projectName: '建立领导班子运行评估和群众口碑评价机制',
                    unitName: '市委组织部',
                    unitTeam: '党建统领体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '2月已完成',
                    target4: '9月已完成',
                    target5: '暂不涉及',
                    target6: '暂不涉及',
                    target7: '6月已完成',
                    target8: '未启动',
                },
                {
                    indexKey: 4,
                    projectName: '推进开发区（园区）优化整合',
                    unitName: '市发展改革委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '推进中',
                    target4: '推进中',
                    target5: '暂不涉及',
                    target6: '推进中',
                    target7: '推进中',
                    target8: '推进中',
                },
                {
                    indexKey: 5,
                    projectName: '探索经济区与行政区适度分离改革',
                    unitName: '市发展改革委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '7月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '推进中',
                    target7: '未启动',
                    target8: '推进中',
                },
                {
                    indexKey: 6,
                    projectName: '推进涉企涉民服务全生命周期“一件事一次办”',
                    unitName: '市政府办公厅',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '5月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '6月已完成',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 7,
                    projectName: '打造“信用重庆”升级版',
                    unitName: '市发展改革委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '7月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '8月已完成',
                    target8: '未启动',
                },
                {
                    indexKey: 8,
                    projectName: '探索制造业“亩均论英雄”改革',
                    unitName: '市经济信息委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '8月已完成',
                    target4: '推进中',
                    target5: '暂不涉及',
                    target6: '7月已完成',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 9,
                    projectName: '实施投融资多元化改革',
                    unitName: '市发展改革委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '7月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 10,
                    projectName: '建立企业上市助推机制',
                    unitName: '市金融监管局',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '7月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 11,
                    projectName: '实施国企战略性重组和专业化整合',
                    unitName: '市国资委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '5月已完成',
                    target4: '推进中',
                    target5: '暂不涉及',
                    target6: '暂不涉及',
                    target7: '推进中',
                    target8: '推进中',
                },
                {
                    indexKey: 12,
                    projectName: '探索强村富民综合改革',
                    unitName: '市农业农村委',
                    unitTeam: '经济体制改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '9月已完成',
                    target4: '推进中',
                    target5: '推进中',
                    target6: '推进中',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 13,
                    projectName: '打造市域产教联合体深化现代职业教育改革',
                    unitName: '市教委',
                    unitTeam: '社会民生领域改革',
                    target1: '3月已完成',
                    target2: '5月已完成',
                    target3: '9月已完成',
                    target4: '推进中',
                    target5: '4月已完成',
                    target6: '推进中',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 14,
                    projectName: '推进渝警智治·“情指行”一体化现代警务改革',
                    unitName: '市公安局',
                    unitTeam: '平安法治领域改革',
                    target1: '3月已完成',
                    target2: '4月已完成',
                    target3: '4月已完成',
                    target4: '5月已完成',
                    target5: '推进中',
                    target6: '5月已完成',
                    target7: '8月已完成',
                    target8: '推进中',
                },
                {
                    indexKey: 15,
                    projectName: '健全平安重庆风险闭环管控机制',
                    unitName: '市委政法委',
                    unitTeam: '平安法治领域改革',
                    target1: '3月已完成',
                    target2: '6月已完成',
                    target3: '4月已完成',
                    target4: '推进中',
                    target5: '暂不涉及',
                    target6: '推进中',
                    target7: '推进中',
                    target8: '未启动',
                },
                {
                    indexKey: 16,
                    projectName: '深化全市机构改革 ',
                    unitName: '市委编办',
                    unitTeam: '党建统领体制改革',
                    target1: '7月已完成',
                    target2: '推进中',
                    target3: '推进中',
                    target4: '未启动',
                    target5: '推进中',
                    target6: '暂不涉及',
                    target7: '未启动',
                    target8: '未启动',
                },
                {
                    indexKey: 17,
                    projectName: '打造践行全过程人民民主基层单元',
                    unitName: '市人大常委会人代工委',
                    unitTeam: '民主与法制领域改革',
                    target1: '4月已完成',
                    target2: '4月已完成',
                    target3: '5月已完成',
                    target4: '8月已完成',
                    target5: '暂不涉及',
                    target6: '推进中',
                    target7: '未启动',
                    target8: '未启动',
                },
            ],
            // tableData: [],
            columnIndexFixed: [
                0, 1, 2, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
            ], // 固定列序号
            columnIndexGather: {}, //固定列序需合并行号集合
            columnIndexTargetName: {}, // 改革核心指标名称需合并行号
            templateData: [],
            scoreData: [],
            scoreObj: {},
        }
    },
    mounted() {
        // this.initData()
        // this.getData()
    },
    created() {
        this.$emit('searchDateChange')
    },
    methods: {
        getData() {
            this.loading = true
            let now = new Date()
            let y = now.getFullYear()
            let m = now.getMonth() + 1
            let data = this.qs.stringify({
                fillMonth: m,
                fillYear: y,
            })
            apiList.getReport(data, (res) => {
                this.templateData = res.target //量化指标
                this.scoreData = res.syn // 得分
                this.tableData = this.dataFormat()
            })
        },
        dataFormat() {
            this.scoreData.forEach((item) => {
                this.scoreObj[item.projectId] = {
                    targetScore: item.targetScore, //目标推进力评分

                    actualRegimeNum: item.actualRegimeNum, //实际形成制度个数
                    actualPlatformNum: item.actualPlatformNum, //实际搭建平台个数
                    actualAppNum: item.actualAppNum, //实际上线应用个数
                    measureScore: item.measureScore, //具体举措推进力评分

                    nationwideNum: item.nationwideNum, //改革经验获全国性肯定评价件次
                    mediaNum: item.mediaNum, //改革经验被5家中央媒体深度专题报道件次
                    brandScore: item.brandScore, //品牌显示度得分

                    satisfaction: item.satisfaction, //满意度
                    opinionNum: item.opinionNum, //引发重大负面舆情或群体性事件件次

                    score: item.score, //综合得分
                    allSn: item.allSn, //综合得分全市排名
                }
            })

            return this.initData()
        },
        initData() {
            // let indexKey = 0
            // 先计算需合并的行号
            this.tableData.map((item, index) => {
                if (!this.columnIndexGather[item.indexKey]) {
                    this.columnIndexGather[item.indexKey] = [index]
                    // indexKey++
                } else {
                    this.columnIndexGather[item.indexKey].push(index)
                }
                if (
                    !this.columnIndexTargetName[
                    item.reformQuantitativeObjectives
                    ]
                ) {
                    this.columnIndexTargetName[
                        item.reformQuantitativeObjectives
                    ] = [index]
                } else {
                    this.columnIndexTargetName[
                        item.reformQuantitativeObjectives
                    ].push(index)
                }
                // item.indexKey = indexKey
                // return {...item, ...this.scoreObj[item.projectId]}
            })
            for (let key in this.columnIndexGather) {
                if (this.columnIndexGather[key].length <= 1) {
                    delete this.columnIndexGather[key]
                }
            }
            for (let key in this.columnIndexTargetName) {
                if (this.columnIndexTargetName[key].length <= 1) {
                    delete this.columnIndexTargetName[key]
                }
            }

            console.log(this.columnIndexTargetName, this.columnIndexGather)

            this.loading = false
            this.dataReady = true
            // return newData
        },
        objectSpanMethod({ row, column, rowIndex, columnIndex }) {
            if (this.columnIndexFixed.includes(columnIndex)) {
                for (let key in this.columnIndexGather) {
                    if (rowIndex === this.columnIndexGather[key][0]) {
                        return {
                            rowspan: this.columnIndexGather[key].length,
                            colspan: 1,
                        }
                    } else if (
                        this.columnIndexGather[key].includes(rowIndex) &&
                        rowIndex !== this.columnIndexGather[key][0]
                    ) {
                        return {
                            rowspan: 0,
                            colspan: 0,
                        }
                    }
                }
            }
            // if (columnIndex == 3) {
            //     for (let key in this.columnIndexTargetName) {
            //         if (rowIndex === this.columnIndexTargetName[key][0]) {
            //             return {
            //                 rowspan: this.columnIndexTargetName[key].length,
            //                 colspan: 1,
            //             }
            //         } else if (
            //             this.columnIndexTargetName[key].includes(rowIndex) &&
            //             rowIndex !== this.columnIndexTargetName[key][0]
            //         ) {
            //             return {
            //                 rowspan: 0,
            //                 colspan: 0,
            //             }
            //         }
            //     }
            // }
        },
    },
}
</script>
<style lang="scss">
#table-bigger-detail .el-table--border th,
.el-table--border td {
    border-right: 1PX solid rgb(39, 86, 162) !important;
}

#table-bigger-detail.el-table th.el-table__cell.is-leaf,
#table-bigger-detail.el-table td.el-table__cell {
    border-bottom: 1PX solid rgb(39, 86, 162) !important;
}

#table-bigger-detail.dialog_table.el-table {
    thead tr {
        background: none !important;
    }

    thead tr,
    thead tr th {
        background: none !important;
        background-color: #114385 !important;
        color: #FFFFFF;
    }

    th>.cell {
        font-size: 16PX;
        font-family: SimHei;
        font-weight: bold;
        color: #FFFFFF;
    }

    td>.cell {
        color: #FFFFFF !important;
        font-size: 16PX;
        line-height: 140%;

        div {
            padding-top: 10PX;
            padding-bottom: 10PX;
            font-size: 16PX;
        }
    }
}

#table-bigger-detail.el-table--border {
    border: 1PX solid rgb(39, 86, 162) !important;

    .el-table__cell {
        border-right: 1PX solid rgb(39, 86, 162) !important;
    }

    th.el-table__cell {
        border-bottom: 1PX solid rgb(39, 86, 162) !important;
    }

    td {
        border-right: 1PX solid rgb(39, 86, 162) !important;
    }

    th {
        border-right: 1PX solid rgb(39, 86, 162) !important;
    }
}

#table-bigger-detail.el-table {
    background-color: transparent;

    tr {
        background-color: rgba(1, 39, 101, 1) !important;
        color: #FFFFFF !important;
    }
}


// #table-bigger-detail .el-table--enable-row-hover .el-table__body tr:hover > td.el-table__cell {
//     background-color: rgba(2, 115, 233, 0.3)!important;
// }
#table-bigger-detail.el-table tbody tr:hover>td {
    background-color: rgba(2, 115, 233, 0.3) !important;
}

#table-bigger-detail.el-table--group::after,
#table-bigger-detail.el-table--border::after,
#table-bigger-detail.el-table::before {
    background-color: #001f47 !important;
}

#table-bigger-detail.el-table th.el-table__cell>.cell {
    white-space: pre;

}

#table-bigger-detail {

    /* 设置滚动条的样式 */
    ::-webkit-scrollbar {
        width: 8PX !important; //垂直方向上的宽
        height: 8PX !important; //水平方向上的宽
    }

    /* 滚动槽 */
    ::-webkit-scrollbar-track {
        border-radius: 0 !important;
        background-color: #01215a !important;
    }

    /* 滚动条滑块 */
    ::-webkit-scrollbar-thumb {
        border-radius: 12PX;
        background-color: rgba(#fff, 0.1) !important;
    }

    /*滚动条交叉样式*/
    ::-webkit-scrollbar-corner {
        background: #01215a !important;
    }
}

.tips {
    font-size: 18PX;
}
</style>
<style lang="scss" scoped>
.report-overview {
    height: 100%;
    margin-top: 5PX;
}

/deep/.dialog_table.el-table {
    th>.cell {
        font-size: 16PX !important;
    }
}
</style>

